/*Relative Searcher v.2.5
by Griffin Knodle, a.k.a. Jair, 10/25/98
E-mail: gknodle@trinity.edu
http://fly.to/vale

TERMS OF USE

This program is distributed with its source code. You may use,
distribute, and modify it freely. Only two restrictions: These terms of use 
must stay the same, and you must always include the source code with the
program. Oh, and I'd appreciate it if you credit me as the original
author.*/

#include <stdio.h>
#include <stdlib.h>
#include "vale.h"

int hexInput(int*);

void main(){
  char fileName[45];
  int entry, c;
  int* input;
  int* rel;
  int* first;
  int* second;
  int* skipFlag;
  int relCount, searchLength, buffer1, buffer2;
  long int pos;
  int file;
  long int offset = 1;
  unsigned char* buffer;
  unsigned int bytesRead;

  input = (int*) malloc(sizeof(int));
  skipFlag = (int*) malloc(sizeof(int));

  getFileName:
  printf("File to search:");
  getString(40, fileName);
  addExt(fileName, "nes");
  file=openFile(fileName,'r');
  if(file==-1){
    printf("Error opening %s!\n\n", fileName);
    goto getFileName;
    }

  printf("\nNow enter values.\n(enter=done)\n(*=skip this byte)\n(h=");
  printf("hexadecimal entry)\n\n");

  for(entry = 0; ; entry++){
    printf("Byte %d:", entry + 1);
    input[entry]=hexInput(&skipFlag[entry]);
    if(skipFlag[entry]==1) break;
    while(input[entry] > 255)
      input[entry] -= 256;
    input = (int*) realloc(input, sizeof(int) * (entry + 2));
    skipFlag = (int*) realloc(skipFlag, sizeof(int) * (entry + 2));
    }

  // entry = number of inputs

  while(skipFlag[entry-1] == 2 && entry > 0){ // No sense having wildcards at the end
    entry--;
    }

  while(skipFlag[0]==2 && entry > 0){ // or the beginning
    for(pos=0; pos < entry - 1; pos++){
      input[pos]=input[pos+1];
      skipFlag[pos]=skipFlag[pos+1];
      }
    entry--;
    }

  if(entry < 2){
    printf("\nYou need at least two values for a relative search!\n");
    exit(1);
    }

  searchLength = entry;
  relCount = entry - 1;
  buffer = (unsigned char*) malloc(sizeof(char) * 30000);

  // make relative search table

  rel = (int*) malloc(sizeof(int));
  first = (int*) malloc(sizeof(int));
  second = (int*) malloc(sizeof(int));

  pos = 0;
  for(c = 0; c < relCount; c++){
    first[c] = pos;
    while(skipFlag[pos + 1] == 2){
      pos++;
      relCount--;
      }
    second[c] = pos + 1;
    rel[c] = input[second[c]] - input[first[c]];
    if(input[second[c]] < input[first[c]])
      rel[c] += 256;
    pos++;
    rel = (int*) realloc(rel, sizeof(int) * (c + 2));
    first = (int*) realloc(first, sizeof(int) * (c + 2));
    second = (int*) realloc(second, sizeof(int) * (c + 2));
    }
  /*for(c = 0; c < relCount; c++)
    printf("%d: 1=%d 2=%d r=%d\n", c, first[c], second[c], rel[c]);*/

  printf("\nSearch:\n");
  for(c = 0; c < relCount; c++){
    printf("     Byte %d to byte %d: %+d\n", first[c] + 1, second[c] + 1, rel[c]);
    }
  printf("\n");

  bytesRead = _read(file, buffer, 30000);

  if(bytesRead < searchLength){
    printf("File not long enough!\n");
    close(file);
    exit(1);
    }

  pos = 0;
  while(bytesRead > 0) {
    /*printf("Checking ");
    for(c = 0; c < 8; c++)
      printf("%c", buffer[c]);
    printf(" ... ");
    for(c = bytesRead - 8; c < bytesRead; c++)
      printf("%c", buffer[c]);
    printf("\n");*/
    while(pos + searchLength - 1 < bytesRead) {

    for(c = 0; c < relCount; c++){
      buffer1 = buffer[pos + first[c]];
      buffer2 = buffer[pos + second[c]];
      if(buffer2 < buffer1)
	buffer2 += 256;
      if(buffer2 - buffer1 != rel[c]) // no match
	break;
      /*if(c > 0) printf("  ");
      printf("%d", pos);
      printf(" %d %d %d %d\n", buffer1, buffer2, c, rel[c]);*/
      }
    if(c == relCount){
      printf("Match at %ld (%lXh)\n", offset + pos, offset + pos);
      }
    pos++;
    }

    for(c = 0; c < searchLength - 1; c++)
      buffer[c] = buffer[bytesRead + 1 - searchLength + c];
    bytesRead = _read(file, &buffer[searchLength - 1], 30000 - searchLength);
    pos = 0;
    offset += 30000 - searchLength;
    }
  
  printf("End of file!\n");
  close(file);
  }

int hexInput(int* flag){
  int value=0;
  char hexFlag=0;
  char negFlag=0;
  char input[10];
  int charsRead=0;
  int x;

  *flag=0;

  for(charsRead=0; ; charsRead++){

  input[charsRead]=getch();

  if(input[charsRead]==13 && charsRead > 0){
    printf("\n");
    break; // enter
    }

  if(input[charsRead]==13){
    printf("Done\n");
    *flag=1; // done
    return 0;
    }
  if(input[charsRead]=='*' && charsRead == 0){
    printf("*\n");
    *flag=2; // wildcard
    return 0;
    }

  if(input[charsRead]==8){ //backspace
    charsRead--;
    if(charsRead==-1 && negFlag==1){
      negFlag=0;
      printf("%c",8);
      }
    if(charsRead==-1) continue; //not if nothing to erase
    if(hexFlag==1) hexFlag=0; // erase H
    else{ // or erase last digit
      charsRead--;
      }
    printf("%c",8);
    continue;
    }
     
  if(hexFlag==1){ // after typing H, only backspace or enter
    charsRead--;
    continue;
    }

  if(input[charsRead]=='h' || input[charsRead]=='H'){  // set H
    charsRead--;
    if(charsRead==-1) continue; // not if no value yet
    hexFlag=1;
    printf("h");
    continue;
    }
  if(charsRead==4){
    charsRead--;
    continue;
    }
  if(input[charsRead]=='-'){ // set neg
    charsRead--;
    if(charsRead > -1) continue; // only at start
    if(negFlag==1) continue; // once is enough
    negFlag=1;
    printf("-");
    continue;
    }
  if(input[charsRead] > 96 && input[charsRead] < 103)
    input[charsRead] -= 32; // a-f -> A-F
  if(input[charsRead] > 64 && input[charsRead] < 71){
    printf("%c",input[charsRead]);
    continue;
    }
  if(input[charsRead] > 47 && input[charsRead] < 58){
    printf("%c",input[charsRead]);
    continue;
    }
  charsRead--;
  }

  if(hexFlag==0){
    for(x=0; x<charsRead; x++){
      if(input[x] > 64 && input[x] < 71){
	hexFlag=1;
	break;
	}
      }
    }

  for(x=0; x < charsRead; x++){ 
    if(hexFlag==1) value *= 16;
    else value *= 10;
    if(input[x] > 47 && input[x] < 58){// digit 0-9
      value += (input[x] - 48);
      }
    if(input[x] > 64 && input[x] < 71){ // hex digit A-F
      value += (input[x] - 55);
      }
    }

  if(negFlag==1) value = (-value);

  //printf("\n%li",value);
  return value;
  }